<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Rastislav Birka (rasto@cs2.ch)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'Unit Converter' for the 'cs2_unitconv' extension.
 *
 * @author	Rastislav Birka <rasto@cs2.ch>
 */



	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);	
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
$LANG->includeLLFile("EXT:cs2_unitconv/mod1/locallang.php");
$LANG->includeLLFile("EXT:cs2_unitconv/locallang_db.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

class tx_cs2unitconv_module1 extends t3lib_SCbase {
	var $pageinfo;

	/**
	 * 
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("function1"),
				"2" => $LANG->getLL("function2"),
				"3" => $LANG->getLL("function3"),
				"4" => $LANG->getLL("function4"),
			)
		);
		parent::menuConfig();
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		
		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		
//		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{
	
				// Draw the header.
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form = '<form name="unitForm" action="'.$GLOBALS['PHP_SELF'].'?id='.$this->id.'&sorting='.t3lib_div::GPvar("sorting").'&sortold='.t3lib_div::GPvar("sortold").'" method="POST">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);

			
			// Render content:
			$this->moduleContent();

			
			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}
		
			$this->content.=$this->doc->spacer(10);
/*		} else {
				// If no access or if ID == zero
		
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
		
			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}*/
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}
	
	/**
	 * Generates the module content
	 */
	function moduleContent()	{
		global $BE_USER,$LANG;
		
		if ($this->id <= 0) {
			$this->id = 1;
			$query = "SELECT uid FROM pages WHERE deleted = 0";
			$res = mysql(TYPO3_db, $query); 
			if ($row = mysql_fetch_assoc($res))
				$this->id = $row['uid'];
		}

		$content = '';
		$listFormulas = '';
		$errorText = '';
		$userScript = '';
		$deleteUid = t3lib_div::GPvar("delete_uid");
		$sorted = t3lib_div::GPvar("sorting");
		$sortOld = t3lib_div::GPvar("sortold");
		$selectGroup = t3lib_div::GPvar("select_group");
		if ($sorted && $sorted == $sortOld)
			$sortType = "DESC";

		switch((string)$this->MOD_SETTINGS["function"])	{
			case 1:
				$tableName = 'tx_cs2unitconverter_groups';
				$tableNameUnits = 'tx_cs2unitconverter_units';
				if ($sorted == '')
					$sorted = 'group_name';
				
				if ($deleteUid) {
					$query = "SELECT uid FROM ".$tableNameUnits." WHERE group_uid = ".intval($deleteUid);
					$res = mysql(TYPO3_db, $query); 
					if ($row = mysql_fetch_assoc($res)) {
						$userScript.='<script language="javascript">';
						$userScript.="alert(\"".$LANG->getLL("deleteGroupNotAllowed")."\");";
						$userScript.='</script>';
					} else {
						$query = "UPDATE ".$tableName." SET deleted = 1 WHERE uid = ".intval($deleteUid);
						$res = mysql(TYPO3_db, $query); 
						echo mysql_error();
					}
					$GLOBALS['HTTP_SERVER_VARS']['QUERY_STRING'] = substr($GLOBALS['HTTP_SERVER_VARS']['QUERY_STRING'], 0, strpos($GLOBALS['HTTP_SERVER_VARS']['QUERY_STRING'], '&delete_uid'));
					$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'] = substr($GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'], 0, strpos($GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'], '&delete_uid'));
				}

 				$query = "SELECT * FROM ".$tableName." WHERE deleted = 0 ORDER BY ".$GLOBALS['TYPO3_DB']->quoteStr($sorted,'')." ".$GLOBALS['TYPO3_DB']->quoteStr($sortType,'');
 				$res = mysql(TYPO3_db, $query);
				if ($res != '') {
					$newsort = $sorted;
					if ($sorted == $sortOld)
						$newsort = "";
					$links[]='<table width="100%" border="0" cellspacing="0" cellpadding="0">';
					$links[]='<tr><td bgcolor="#DFDFDF"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/ol/blank.gif" width="18" height="16" border="0" alt="" align="absmiddle"><a href="index.php?id='.$this->id.'&sorting=group_name&sortold='.$newsort.'">'.$LANG->getLL("tx_cs2unitconverter_groups.group_name").'</a></td>';
					$links[]='<td bgcolor="#DFDFDF"><a href="index.php?id='.$this->id.'&sorting=group_name_de&sortold='.$newsort.'">'.$LANG->getLL("tx_cs2unitconverter_groups.group_name_de").'</a></td>';
					$links[]='<td bgcolor="#DFDFDF"><a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick('&edit['.$tableName.']['.$this->id.']=new',$GLOBALS["BACK_PATH"])).'"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/new_el.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showNew").'" align="absmiddle"></a></td></tr>';
  				while($row = mysql_fetch_assoc($res)) {
						if ($row['hidden'] == 0) 
							$imgsrc = '../icon_tx_cs2unitconverter_groups.gif';
						else
							$imgsrc = '../icon_tx_cs2unitconverter_groups__h.gif';
						$links[]='<tr><td><img src="'.$imgsrc.'" width="18" height="16" border="0" alt="" align="absmiddle">'.htmlspecialchars($row['group_name']).'</td>';
						$links[]='<td>'.htmlspecialchars($row['group_name_de']).'</td>';
						$links[]='<td><a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick('&edit['.$tableName.']['.$row['uid'].']=edit',$GLOBALS["BACK_PATH"])).'"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/edit2.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showEdit").'" align="absmiddle"></a>';
						$links[]='<a href="#" onclick="'.htmlspecialchars('top.launchView(\''.$tableName.'\', \''.$row['uid'].'\'); return false;').'">'.'<img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/zoom2.gif" width="12" height="12" border="0" alt="'.$LANG->getLL("showInfo").'" align="absmiddle"></a>';
						$links[]='<a href="#" onclick="'.htmlspecialchars('if (confirm('.$LANG->JScharCode($LANG->getLL('deleteWarning')).')) {jumpToUrl(\'index.php?id='.$this->id.'&sorting='.$sorted.'&sortold='.$sortOld.'&delete_uid='.$row['uid'].'\');} return false;').'">'.'<img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/delete_record.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showDelete").'" align="absmiddle">'.'</a></td></tr>'; 
  				}
					$links[]='</table>';
 					$listFormulas.= implode("",$links);
				} else {
					$errorText = mysql_error();
				}
				if ($errorText != '') {
					$userScript.='<script language="javascript">';
					$userScript.="alert(\"".$errorText."\");";
					$userScript.='</script>';
				}
				$content.=$listFormulas.$userScript;
				$this->content.=$this->doc->section($LANG->getLL("function1"),$content,0,1);
				break;
			case 2:
				$tableName = 'tx_cs2unitconverter_units';
				$tableNameGroups = 'tx_cs2unitconverter_groups';
				$tableNameFormulas = 'tx_cs2unitconverter_formulas';
				if ($sorted == '')
					$sorted = 'unit_name';
				
				if ($deleteUid) {
					$query = "SELECT uid FROM ".$tableNameFormulas." WHERE source_unit = ".intval($deleteUid)." OR target_unit = ".intval($deleteUid);
					$res = mysql(TYPO3_db, $query); 
					if ($row = mysql_fetch_assoc($res)) {
						$userScript.='<script language="javascript">';
						$userScript.="alert(\"".$LANG->getLL("deleteUnitNotAllowed")."\");";
						$userScript.='</script>';
					} else {
						$query = "UPDATE ".$tableName." SET deleted = 1 WHERE uid = ".intval($deleteUid);
						$res = mysql(TYPO3_db, $query); 
						echo mysql_error();
					}
					$GLOBALS['HTTP_SERVER_VARS']['QUERY_STRING'] = substr($GLOBALS['HTTP_SERVER_VARS']['QUERY_STRING'], 0, strpos($GLOBALS['HTTP_SERVER_VARS']['QUERY_STRING'], '&delete_uid'));
					$GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'] = substr($GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'], 0, strpos($GLOBALS['HTTP_SERVER_VARS']['REQUEST_URI'], '&delete_uid'));
				}

 				$numGroups = 0;
 				$query = "SELECT * FROM ".$tableNameGroups." WHERE deleted = 0 ORDER BY group_name";
 				$res = mysql(TYPO3_db, $query);
				if ($res != '') {
					if (empty($selectGroup))
						$selectGroup = 0;
					$groupsOption ='<OPTION value="0">'.$LANG->getLL('allText').'</OPTION>';
  				while ($row = mysql_fetch_assoc($res)) {
						$numGroups++;
						$opt_selected = '';
						if ($row['uid'] == $selectGroup) {
							$opt_selected = "SELECTED";	
						}
						$textName = $row['group_name'];
						if ($row['group_name_de']) 
							$textName.= ' ('.$row['group_name_de'].')';
						$groupsOption.='<OPTION value="'.$row['uid'].'" '.$opt_selected.'>'.$textName.'</OPTION>';
					}
					$links[]='<select name="select_group" onChange="this.form.submit();">'.$groupsOption.'</select>';

	 				$query = "SELECT t1.* FROM ".$tableName." t1, ".$tableNameGroups." t2";
	 				$query.= " WHERE t2.uid = t1.group_uid AND t1.deleted = 0 AND t2.deleted = 0";
					if ($selectGroup > 0)
		 				$query.= " AND t1.group_uid = ".$selectGroup;
	 				$query.= " ORDER BY ".$GLOBALS['TYPO3_DB']->quoteStr($sorted,'')." ".$GLOBALS['TYPO3_DB']->quoteStr($sortType,'');
	 				$res = mysql(TYPO3_db, $query);
					if ($res != '') {
						$newsort = $sorted;
						if ($sorted == $sortOld)
							$newsort = "";
						$requestUri = strpos(t3lib_div::getIndpEnv('REQUEST_URI'), '?') > 0 ?
													t3lib_div::getIndpEnv('REQUEST_URI').'&select_group='.$selectGroup :
													t3lib_div::getIndpEnv('REQUEST_URI').'?select_group='.$selectGroup;
						$links[]='<table width="100%" border="0" cellspacing="0" cellpadding="0">';
						$links[]='<tr><td bgcolor="#DFDFDF"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/ol/blank.gif" width="18" height="16" border="0" alt="" align="absmiddle"><a href="index.php?id='.$this->id.'&sorting=unit_name&sortold='.$newsort.'&select_group='.$selectGroup.'">'.$LANG->getLL("tx_cs2unitconverter_units.unit_name").'</a></td>';
						$links[]='<td bgcolor="#DFDFDF"><a href="index.php?id='.$this->id.'&sorting=unit_name_de&sortold='.$newsort.'&select_group='.$selectGroup.'">'.$LANG->getLL("tx_cs2unitconverter_units.unit_name_de").'</a></td>';
						$links[]='<td bgcolor="#DFDFDF"><a href="index.php?id='.$this->id.'&sorting=shortcut&sortold='.$newsort.'&select_group='.$selectGroup.'">'.$LANG->getLL("tx_cs2unitconverter_units.shortcut").'</a></td>';
						if ($numGroups > 0)
							$links[]='<td bgcolor="#DFDFDF"><a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick('&edit['.$tableName.']['.$this->id.']=new&select_group='.$selectGroup,$GLOBALS["BACK_PATH"],$requestUri)).'"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/new_el.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showNew").'" align="absmiddle"></a></td></tr>';
						else
							$links[]='<td bgcolor="#DFDFDF"></td></tr>';
	  				while($row = mysql_fetch_assoc($res)) {
							if ($row['hidden'] == 0) 
								$imgsrc = '../icon_tx_cs2unitconverter_units.gif';
							else
								$imgsrc = '../icon_tx_cs2unitconverter_units__h.gif';
							$links[]='<tr><td><img src="'.$imgsrc.'" width="18" height="16" border="0" alt="" align="absmiddle">'.htmlspecialchars($row['unit_name']).'</td>';
							$links[]='<td>'.htmlspecialchars($row['unit_name_de']).'</td>';
							$links[]='<td>'.htmlspecialchars($row['shortcut']).'</td>';
							$links[]='<td><a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick('&edit['.$tableName.']['.$row['uid'].']=edit&select_group='.$row['group_uid'],$GLOBALS["BACK_PATH"],$requestUri)).'"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/edit2.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showEdit").'" align="absmiddle"></a>';
							$links[]='<a href="#" onclick="'.htmlspecialchars('top.launchView(\''.$tableName.'\', \''.$row['uid'].'\'); return false;').'">'.'<img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/zoom2.gif" width="12" height="12" border="0" alt="'.$LANG->getLL("showInfo").'" align="absmiddle"></a>';
							$links[]='<a href="#" onclick="'.htmlspecialchars('if (confirm('.$LANG->JScharCode($LANG->getLL('deleteWarning')).')) {jumpToUrl(\'index.php?id='.$this->id.'&sorting='.$sorted.'&sortold='.$sortOld.'&select_group='.$selectGroup.'&delete_uid='.$row['uid'].'\');} return false;').'">'.'<img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/delete_record.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showDelete").'" align="absmiddle">'.'</a></td></tr>'; 
	  				}
						$links[]='</table>';
	 					$listFormulas.= implode("",$links);
					} else {
						$errorText = mysql_error();
					}
				} else {
					$errorText = mysql_error();
				}
				if ($errorText != '') {
					$userScript.='<script language="javascript">';
					$userScript.="alert(\"".$errorText."\");";
					$userScript.='</script>';
				}
				$content.=$listFormulas.$userScript;
				$this->content.=$this->doc->section($LANG->getLL("function2"),$content,0,1);
				break;
			case 3:
				$tableName = 'tx_cs2unitconverter_formulas';
				$tableNameUnits = 'tx_cs2unitconverter_units';
				$tableNameGroups = 'tx_cs2unitconverter_groups';
				if ($sorted == '')
					$sorted = 'so_name';
				
				if ($deleteUid) {
					$query = "UPDATE ".$tableName." SET deleted = 1 WHERE uid = ".intval($deleteUid);
					$res = mysql(TYPO3_db, $query); 
					echo mysql_error();
				}

 				$query = "SELECT t1.* FROM ".$tableNameGroups." t1, ".$tableNameUnits." t2";
 				$query.= " WHERE t1.deleted = 0 AND t2.deleted = 0 AND t2.group_uid = t1.uid";
 				$query.= " GROUP BY t1.uid ORDER BY t1.group_name";
 				$res = mysql(TYPO3_db, $query);
				if ($res != '') {
					if (empty($selectGroup))
						$selectGroup = 0;
					$groupsOption ='<OPTION value="0">'.$LANG->getLL('allText').'</OPTION>';
  				while ($row = mysql_fetch_assoc($res)) {
						$opt_selected = '';
						if ($row['uid'] == $selectGroup) {
							$opt_selected = "SELECTED";	
						}
						$textName = $row['group_name'];
						if ($row['group_name_de']) 
							$textName.= ' ('.$row['group_name_de'].')';
						$groupsOption.='<OPTION value="'.$row['uid'].'" '.$opt_selected.'>'.$textName.'</OPTION>';
					}
					$links[]='<select name="select_group" onChange="this.form.submit();">'.$groupsOption.'</select>';

	 				$query = "SELECT t1.*, t2.group_uid as so_group_uid, t2.unit_name as so_name, t2.unit_name_de as so_name_de, t2.shortcut as so_short, t3.unit_name as ta_name, t3.unit_name_de as ta_name_de, t3.shortcut as ta_short";
	 				$query.= " FROM ".$tableName." t1, ".$tableNameUnits." t2, ".$tableNameUnits." t3";
	 				$query.= " WHERE t1.deleted = 0 AND t2.deleted = 0 AND t3.deleted = 0 AND t2.uid = t1.source_unit AND t3.uid = t1.target_unit";
					if ($selectGroup > 0)
		 				$query.= " AND t2.group_uid = ".intval($selectGroup);
	 				$query.= " ORDER BY ".$GLOBALS['TYPO3_DB']->quoteStr($sorted,'')." ".$GLOBALS['TYPO3_DB']->quoteStr($sortType,'');

	 				$res = mysql(TYPO3_db, $query);
					if ($res != '') {
						$newsort = $sorted;
						if ($sorted == $sortOld)
							$newsort = "";
						$requestUri = strpos(t3lib_div::getIndpEnv('REQUEST_URI'), '?') > 0 ?
													t3lib_div::getIndpEnv('REQUEST_URI').'&select_group='.$selectGroup :
													t3lib_div::getIndpEnv('REQUEST_URI').'?select_group='.$selectGroup;
						$links[]='<table width="100%" border="0" cellspacing="0" cellpadding="0">';
						$links[]='<tr><td bgcolor="#DFDFDF"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/ol/blank.gif" width="18" height="16" border="0" alt="" align="absmiddle"><a href="index.php?id='.$this->id.'&sorting=so_name&sortold='.$newsort.'&select_group='.$selectGroup.'">'.$LANG->getLL("tx_cs2unitconverter_formulas.source_unit").'</a></td>';
						$links[]='<td bgcolor="#DFDFDF"><a href="index.php?id='.$this->id.'&sorting=ta_name&sortold='.$newsort.'&select_group='.$selectGroup.'">'.$LANG->getLL("tx_cs2unitconverter_formulas.target_unit").'</a></td>';
						$links[]='<td bgcolor="#DFDFDF"><a href="index.php?id='.$this->id.'&sorting=formula&sortold='.$newsort.'&select_group='.$selectGroup.'">'.$LANG->getLL("tx_cs2unitconverter_formulas.formula").'</a></td>';
						if ($selectGroup > 0)
							$links[]='<td bgcolor="#DFDFDF"><a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick('&edit['.$tableName.']['.$this->id.']=new&select_group='.$selectGroup,$GLOBALS["BACK_PATH"],$requestUri)).'"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/new_el.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showNew").'" align="absmiddle"></a></td></tr>';
						else
							$links[]='<td bgcolor="#DFDFDF"></td></tr>';
	  				while($row = mysql_fetch_assoc($res)) {
							if ($row['hidden'] == 0) 
								$imgsrc = '../icon_tx_cs2unitconverter_formulas.gif';
							else
								$imgsrc = '../icon_tx_cs2unitconverter_formulas__h.gif';
							$textName = $row['so_name'];
//							if ($row['so_name_de']) 
//								$textName.= ' ('.$row['so_name_de'].')';
							if ($row['so_short']) 
								$textName.= ' ('.$row['so_short'].')';
							$links[]='<tr><td><img src="'.$imgsrc.'" width="18" height="16" border="0" alt="" align="absmiddle">'.htmlspecialchars($textName).'</td>';
							$textName = $row['ta_name'];
//							if ($row['ta_name_de']) 
//								$textName.= ' ('.$row['ta_name_de'].')';
							if ($row['ta_short']) 
								$textName.= ' ('.$row['ta_short'].')';
							$links[]='<td>'.htmlspecialchars($textName).'</td>';
							$links[]='<td>'.htmlspecialchars($row['formula']).'</td>';
							$links[]='<td><a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::editOnClick('&edit['.$tableName.']['.$row['uid'].']=edit&select_group='.$row['so_group_uid'],$GLOBALS["BACK_PATH"],$requestUri)).'"><img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/edit2.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showEdit").'" align="absmiddle"></a>';
							$links[]='<a href="#" onclick="'.htmlspecialchars('top.launchView(\''.$tableName.'\', \''.$row['uid'].'\'); return false;').'">'.'<img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/zoom2.gif" width="12" height="12" border="0" alt="'.$LANG->getLL("showInfo").'" align="absmiddle"></a>';
							$links[]='<a href="#" onclick="'.htmlspecialchars('if (confirm('.$LANG->JScharCode($LANG->getLL('deleteWarning')).')) {jumpToUrl(\'index.php?id='.$this->id.'&sorting='.$sorted.'&sortold='.$sortOld.'&select_group='.$selectGroup.'&delete_uid='.$row['uid'].'\');} return false;').'">'.'<img src="'.$GLOBALS["BACK_PATH"].'t3lib/gfx/delete_record.gif" width="11" height="12" border="0" alt="'.$LANG->getLL("showDelete").'" align="absmiddle">'.'</a></td></tr>'; 
	  				}
						$links[]='</table>';
	 					$listFormulas.= implode("",$links);
					} else {
						$errorText = mysql_error();
					}
				} else {
					$errorText = mysql_error();
				}
				if ($errorText != '') {
					$userScript.='<script language="javascript">';
					$userScript.="alert(\"".$errorText."\");";
					$userScript.='</script>';
				}
				$content.=$listFormulas.$userScript;
				$this->content.=$this->doc->section($LANG->getLL("function3"),$content,0,1);
				break;
			case 4:
				$submitLoad = t3lib_div::GPvar("submit_load");
				$submitConfirm = t3lib_div::GPvar("submit_confirm");
				$checkArea = t3lib_div::GPvar("check_area");
				$checkEnergy = t3lib_div::GPvar("check_energy");
				$checkLength = t3lib_div::GPvar("check_length");
				$checkMass = t3lib_div::GPvar("check_mass");
				$checkPower = t3lib_div::GPvar("check_power");
				$checkPressure = t3lib_div::GPvar("check_pressure");
				$checkSpeed = t3lib_div::GPvar("check_speed");
				$checkTemperature = t3lib_div::GPvar("check_temperature");
				$checkVolume = t3lib_div::GPvar("check_volume");
				$checkedArea = $checkArea ? 'CHECKED' : '';
				$checkedEnergy = $checkEnergy ? 'CHECKED' : '';
				$checkedLength = $checkLength ? 'CHECKED' : '';
				$checkedMass = $checkMass ? 'CHECKED' : '';
				$checkedPower = $checkPower ? 'CHECKED' : '';
				$checkedPressure = $checkPressure ? 'CHECKED' : '';
				$checkedSpeed = $checkSpeed ? 'CHECKED' : '';
				$checkedTemperature = $checkTemperature ? 'CHECKED' : '';
				$checkedVolume = $checkVolume ? 'CHECKED' : '';

				$listFormulas = $LANG->getLL('loadText').'<br/><br/>
												<table width="100%" border="0" cellspacing="0" cellpadding="0">
													<tr>
														<td width="25"><input type="checkbox" name="check_area" value="1" '.$checkedArea.'/></td>
														<td>Area (Flchenmasse)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_energy" value="1" '.$checkedEnergy.'/></td>
														<td>Energy (Energie und Arbeit)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_length" value="1" '.$checkedLength.'/></td>
														<td>Length (Lngenmasse)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_mass" value="1" '.$checkedMass.'/></td>
														<td>Mass (Masse)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_power" value="1" '.$checkedPower.'/></td>
														<td>Power (Leistung)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_pressure" value="1" '.$checkedPressure.'/></td>
														<td>Pressure (Druck)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_speed" value="1" '.$checkedSpeed.'/></td>
														<td>Speed (Geschwindigkeit)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_temperature" value="1" '.$checkedTemperature.'/></td>
														<td>Temperature (Temperatur)</td>
													</tr>
													<tr>
														<td width="25"><input type="checkbox" name="check_volume" value="1" '.$checkedVolume.'/></td>
														<td>Volume (Volumen)</td>
													</tr>
													<tr>
														<td></td>
														<td><br/><input type="submit" name="submit_load" value="'.$LANG->getLL('loadButton').'"/></td>
													</tr>
												</table>
												<input type="hidden" name="submit_confirm" value="0">
												';

				if ($submitConfirm == 1) {
					$res = mysql(TYPO3_db, "START TRANSACTION");
					if ($res != '') {
						for ($i = 0; $i < 9; $i++) {
							$insertGroup = array();
							$insertUnit = array();
							$insertFormula = array();
							switch($i) {
								case 0:
									$textName = 'Area';
									$textValue = $checkArea;
									$insertGroup[]		= array('Area',									'Flchenmasse');
									$insertUnit[]			= array('square millimetre',		'square millimetre',		'mm2');
									$insertUnit[]			= array('square centimetre',		'square centimetre',		'cm2');
									$insertUnit[]			= array('square metre',					'square metre',					'm2');
									$insertUnit[]			= array('square kilometre',			'square kilometre',			'km2');
									$insertUnit[]			= array('square inch',					'square inch',					'in2');
									$insertUnit[]			= array('square foot',					'square foot',					'ft2');
									$insertUnit[]			= array('square yard',					'square yard',					'yd2');
									$insertUnit[]			= array('square mile',					'square mile',					'mi2');
									$insertUnit[]			= array('hectare',							'hectare',							'ha');
									$insertUnit[]			= array('acre',									'acre',									'ac');

									$insertFormula[]	= array('square millimetre',		'square centimetre',		'X/100');
									$insertFormula[]	= array('square millimetre',		'square metre',					'X/1e6');
									$insertFormula[]	= array('square millimetre',		'square kilometre',			'X/1e12');
									$insertFormula[]	= array('square millimetre',		'square inch',					'X/645.16');
									$insertFormula[]	= array('square millimetre',		'square foot',					'X/92903.04');
									$insertFormula[]	= array('square millimetre',		'square yard',					'X/836127.36');
									$insertFormula[]	= array('square millimetre',		'square mile',					'X/2589988110336');
									$insertFormula[]	= array('square millimetre',		'hectare',							'X/1e10');
									$insertFormula[]	= array('square millimetre',		'acre',									'X*640/2589988110336');
									$insertFormula[]	= array('square centimetre',		'square millimetre',		'X*100');
									$insertFormula[]	= array('square centimetre',		'square metre',					'X/1e4');
									$insertFormula[]	= array('square centimetre',		'square kilometre',			'X/1e10');
									$insertFormula[]	= array('square centimetre',		'square inch',					'X/6.4516');
									$insertFormula[]	= array('square centimetre',		'square foot',					'X/929.0304');
									$insertFormula[]	= array('square centimetre',		'square yard',					'X/8361.2736');
									$insertFormula[]	= array('square centimetre',		'square mile',					'X/25899881103.36');
									$insertFormula[]	= array('square centimetre',		'hectare',							'X/1e8');
									$insertFormula[]	= array('square centimetre',		'acre',									'X*640/25899881103.36');
									$insertFormula[]	= array('square metre',					'square millimetre',		'X*1e6');
									$insertFormula[]	= array('square metre',					'square centimetre',		'X*1e4');
									$insertFormula[]	= array('square metre',					'square kilometre',			'X/1e6');
									$insertFormula[]	= array('square metre',					'square inch',					'X/6.4516e4');
									$insertFormula[]	= array('square metre',					'square foot',					'X/0.09290304');
									$insertFormula[]	= array('square metre',					'square yard',					'X/0.83612736');
									$insertFormula[]	= array('square metre',					'square mile',					'X/2589988.110336');
									$insertFormula[]	= array('square metre',					'hectare',							'X/1e4');
									$insertFormula[]	= array('square metre',					'acre',									'X*640/2589988.110336');
									$insertFormula[]	= array('square kilometre',			'square millimetre',		'X*1e12');
									$insertFormula[]	= array('square kilometre',			'square centimetre',		'X*1e10');
									$insertFormula[]	= array('square kilometre',			'square metre',					'X*1e6');
									$insertFormula[]	= array('square kilometre',			'square inch',					'X/6.4516e10');
									$insertFormula[]	= array('square kilometre',			'square foot',					'X/9.290304e8');
									$insertFormula[]	= array('square kilometre',			'square yard',					'X/8.3612736e7');
									$insertFormula[]	= array('square kilometre',			'square mile',					'X/2.589988110336');
									$insertFormula[]	= array('square kilometre',			'hectare',							'X*100');
									$insertFormula[]	= array('square kilometre',			'acre',									'X*640/2.589988110336');
									$insertFormula[]	= array('square inch',					'square millimetre',		'X*645.16');																																																		
									$insertFormula[]	= array('square inch',					'square centimetre',		'X*6.4516');																																																		
									$insertFormula[]	= array('square inch',					'square metre',					'X*6.4516/1e4');																																																		
									$insertFormula[]	= array('square inch',					'square kilometre',			'X*6.4516/1e10');																																																		
									$insertFormula[]	= array('square inch',					'square foot',					'X/144');																																																		
									$insertFormula[]	= array('square inch',					'square yard',					'X/1296');																																																		
									$insertFormula[]	= array('square inch',					'square mile',					'X/4014489600');																																																		
									$insertFormula[]	= array('square inch',					'hectare',							'X*6.4516/1e8');																																																		
									$insertFormula[]	= array('square inch',					'acre',									'X/6272640');																																																		
									$insertFormula[]	= array('square foot',					'square millimetre',		'X*92903.04');																																																		
									$insertFormula[]	= array('square foot',					'square centimetre',		'X*929.0304');																																																		
									$insertFormula[]	= array('square foot',					'square metre',					'X*0.09290304');																																																		
									$insertFormula[]	= array('square foot',					'square kilometre',			'X*9.290304/1e8');																																																		
									$insertFormula[]	= array('square foot',					'square inch',					'X*144');																																																		
									$insertFormula[]	= array('square foot',					'square yard',					'X/9');																																																		
									$insertFormula[]	= array('square foot',					'square mile',					'X/27878400');																																																		
									$insertFormula[]	= array('square foot',					'hectare',							'X*9.290304/1e6');																																																		
									$insertFormula[]	= array('square foot',					'acre',									'X/43560');																																																		
									$insertFormula[]	= array('square yard',					'square millimetre',		'X*836127.36');																																																		
									$insertFormula[]	= array('square yard',					'square centimetre',		'X*8361.2736');																																																		
									$insertFormula[]	= array('square yard',					'square metre',					'X*0.83612736');																																																		
									$insertFormula[]	= array('square yard',					'square kilometre',			'X*8.3612736/1e7');																																																		
									$insertFormula[]	= array('square yard',					'square inch',					'X*1296');																																																		
									$insertFormula[]	= array('square yard',					'square foot',					'X*9');																																																		
									$insertFormula[]	= array('square yard',					'square mile',					'X/3097600');																																																		
									$insertFormula[]	= array('square yard',					'hectare',							'X*8.3612736/1e5');																																																		
									$insertFormula[]	= array('square yard',					'acre',									'X/4840');																																																		
									$insertFormula[]	= array('square mile',					'square millimetre',		'X*2589988110336');																																																		
									$insertFormula[]	= array('square mile',					'square centimetre',		'X*25899881103.36');																																																		
									$insertFormula[]	= array('square mile',					'square metre',					'X*2589988.110336');																																																																												
									$insertFormula[]	= array('square mile',					'square kilometre',			'X*2.589988110336');																																																																												
									$insertFormula[]	= array('square mile',					'square inch',					'X*4014489600');																																																																												
									$insertFormula[]	= array('square mile',					'square foot',					'X*27878400');																																																																												
									$insertFormula[]	= array('square mile',					'square yard',					'X*3097600');																																																																												
									$insertFormula[]	= array('square mile',					'hectare',							'X*258.9988110336');																																																																												
									$insertFormula[]	= array('square mile',					'acre',									'X*640');																																																																												
									$insertFormula[]	= array('hectare',							'square millimetre',		'X*1e10');
									$insertFormula[]	= array('hectare',							'square centimetre',		'X*1e8');
									$insertFormula[]	= array('hectare',							'square metre',					'X*1e4');
									$insertFormula[]	= array('hectare',							'square kilometre',			'X/100');
									$insertFormula[]	= array('hectare',							'square inch',					'X/6.4516e8');
									$insertFormula[]	= array('hectare',							'square foot',					'X/9.290304e6');
									$insertFormula[]	= array('hectare',							'square yard',					'X/8.3612736e5');
									$insertFormula[]	= array('hectare',							'square mile',					'X/258.9988110336');
									$insertFormula[]	= array('hectare',							'acre',									'X*640/258.9988110336');
									$insertFormula[]	= array('acre',									'square millimetre',		'X/640*2589988110336');
									$insertFormula[]	= array('acre',									'square centimetre',		'X/640*25899881103.36');
									$insertFormula[]	= array('acre',									'square metre',					'X/640*2589988.110336');
									$insertFormula[]	= array('acre',									'square kilometre',			'X/640*2.589988110336');
									$insertFormula[]	= array('acre',									'square inch',					'X*6272640');
									$insertFormula[]	= array('acre',									'square foot',					'X*43560');
									$insertFormula[]	= array('acre',									'square yard',					'X*4840');
									$insertFormula[]	= array('acre',									'square mile',					'X/640');
									$insertFormula[]	= array('acre',									'hectare',							'X/640*258.9988110336');
									break;
								case 1:
									$textName = 'Energy';
									$textValue = $checkEnergy;
									$insertGroup[]		= array('Energy',								'Energie und Arbeit');
									$insertUnit[]			= array('joule',								'joule',								'J');
									$insertUnit[]			= array('newton metre',					'newton metre',					'Nm');
									$insertUnit[]			= array('erg',									'erg',									'erg');
									$insertUnit[]			= array('watt seconds',					'watt seconds',					'Ws');
									$insertUnit[]			= array('kilowatt hours',				'kilowatt hours',				'kWh');
									$insertUnit[]			= array('calorie',							'calorie',							'cal');

									$insertFormula[]	= array('joule',								'newton metre',					'X');
									$insertFormula[]	= array('joule',								'erg',									'X*1e7');
									$insertFormula[]	= array('joule',								'watt seconds',					'X');
									$insertFormula[]	= array('joule',								'kilowatt hours',				'X/3.6e6');
									$insertFormula[]	= array('joule',								'calorie',							'X/4.1868');
									$insertFormula[]	= array('newton metre',					'joule',								'X');
									$insertFormula[]	= array('newton metre',					'erg',									'X*1e7');
									$insertFormula[]	= array('newton metre',					'watt seconds',					'X');
									$insertFormula[]	= array('newton metre',					'kilowatt hours',				'X/3.6e6');
									$insertFormula[]	= array('newton metre',					'calorie',							'X/4.1868');
									$insertFormula[]	= array('erg',									'joule',								'X/1e7');
									$insertFormula[]	= array('erg',									'newton metre',					'X/1e7');
									$insertFormula[]	= array('erg',									'watt seconds',					'X/1e7');
									$insertFormula[]	= array('erg',									'kilowatt hours',				'X/3.6e13');
									$insertFormula[]	= array('erg',									'calorie',							'X/4.1868e7');
									$insertFormula[]	= array('watt seconds',					'joule',								'X');
									$insertFormula[]	= array('watt seconds',					'newton metre',					'X');
									$insertFormula[]	= array('watt seconds',					'erg',									'X*1e7');
									$insertFormula[]	= array('watt seconds',					'kilowatt hours',				'X/3.6e6');
									$insertFormula[]	= array('watt seconds',					'calorie',							'X/4.1868');
									$insertFormula[]	= array('kilowatt hours',				'joule',								'X*3.6e6');
									$insertFormula[]	= array('kilowatt hours',				'newton metre',					'X*3.6e6');
									$insertFormula[]	= array('kilowatt hours',				'erg',									'X*3.6e13');
									$insertFormula[]	= array('kilowatt hours',				'watt seconds',					'X*3.6e6');
									$insertFormula[]	= array('kilowatt hours',				'calorie',							'X*3.6e6/4.1868');
									$insertFormula[]	= array('calorie',							'joule',								'X*4.1868');
									$insertFormula[]	= array('calorie',							'newton metre',					'X*4.1868');
									$insertFormula[]	= array('calorie',							'erg',									'X*4.1868e7');
									$insertFormula[]	= array('calorie',							'watt seconds',					'X*4.1868');
									$insertFormula[]	= array('calorie',							'kilowatt hours',				'X/3.6e6*4.1868');
									break;
								case 2:
									$textName = 'Length';
									$textValue = $checkLength;
									$insertGroup[]		= array('Length',								'Lngenmasse');
									$insertUnit[]			= array('nanometre',						'nanometre',						'nm');
									$insertUnit[]			= array('micrometre',						'micrometre',						'm');
									$insertUnit[]			= array('millimetre',						'millimetre',						'mm');
									$insertUnit[]			= array('centimetre',						'centimetre',						'cm');
									$insertUnit[]			= array('metre',								'metre',								'm');
									$insertUnit[]			= array('kilometre',						'kilometre',						'km');
									$insertUnit[]			= array('inch',									'inch',									'in');
									$insertUnit[]			= array('foot',									'foot',									'ft');
									$insertUnit[]			= array('yard',									'yard',									'yd');
									$insertUnit[]			= array('mile',									'mile',									'mi');

									$insertFormula[]	= array('nanometre',						'micrometre',						'X/1e3');
									$insertFormula[]	= array('nanometre',						'millimetre',						'X/1e6');
									$insertFormula[]	= array('nanometre',						'centimetre',						'X/1e7');
									$insertFormula[]	= array('nanometre',						'metre',								'X/1e9');
									$insertFormula[]	= array('nanometre',						'kilometre',						'X/1e12');
									$insertFormula[]	= array('nanometre',						'inch',									'X/25.4e6');
									$insertFormula[]	= array('nanometre',						'foot',									'X/304.8e6');
									$insertFormula[]	= array('nanometre',						'yard',									'X/914.4e6');
									$insertFormula[]	= array('nanometre',						'mile',									'X/1609344e6');
									$insertFormula[]	= array('micrometre',						'nanometre',						'X*1e3');
									$insertFormula[]	= array('micrometre',						'millimetre',						'X/1e3');
									$insertFormula[]	= array('micrometre',						'centimetre',						'X/1e4');
									$insertFormula[]	= array('micrometre',						'metre',								'X/1e6');
									$insertFormula[]	= array('micrometre',						'kilometre',						'X/1e9');
									$insertFormula[]	= array('micrometre',						'inch',									'X/25.4e3');
									$insertFormula[]	= array('micrometre',						'foot',									'X/304.8e3');
									$insertFormula[]	= array('micrometre',						'yard',									'X/914.4e3');
									$insertFormula[]	= array('micrometre',						'mile',									'X/1609344e3');
									$insertFormula[]	= array('millimetre',						'nanometre',						'X*1e6');
									$insertFormula[]	= array('millimetre',						'micrometre',						'X*1e3');
									$insertFormula[]	= array('millimetre',						'centimetre',						'X/10');
									$insertFormula[]	= array('millimetre',						'metre',								'X/1e3');
									$insertFormula[]	= array('millimetre',						'kilometre',						'X/1e6');
									$insertFormula[]	= array('millimetre',						'inch',									'X/25.4');
									$insertFormula[]	= array('millimetre',						'foot',									'X/304.8');
									$insertFormula[]	= array('millimetre',						'yard',									'X/914.4');
									$insertFormula[]	= array('millimetre',						'mile',									'X/1609344');
									$insertFormula[]	= array('centimetre',						'nanometre',						'X*1e7');
									$insertFormula[]	= array('centimetre',						'micrometre',						'X*1e4');
									$insertFormula[]	= array('centimetre',						'millimetre',						'X*10');
									$insertFormula[]	= array('centimetre',						'metre',								'X/100');
									$insertFormula[]	= array('centimetre',						'kilometre',						'X/1e5');
									$insertFormula[]	= array('centimetre',						'inch',									'X/2.54');
									$insertFormula[]	= array('centimetre',						'foot',									'X/30.48');
									$insertFormula[]	= array('centimetre',						'yard',									'X/91.44');
									$insertFormula[]	= array('centimetre',						'mile',									'X/160934.4');
									$insertFormula[]	= array('metre',								'nanometre',						'X*1e9');
									$insertFormula[]	= array('metre',								'micrometre',						'X*1e6');
									$insertFormula[]	= array('metre',								'millimetre',						'X*1e3');
									$insertFormula[]	= array('metre',								'centimetre',						'X*100');
									$insertFormula[]	= array('metre',								'kilometre',						'X/1e3');
									$insertFormula[]	= array('metre',								'inch',									'X/0.0254');
									$insertFormula[]	= array('metre',								'foot',									'X/0.3048');
									$insertFormula[]	= array('metre',								'yard',									'X/0.9144');
									$insertFormula[]	= array('metre',								'mile',									'X/1609.344');
									$insertFormula[]	= array('kilometre',						'nanometre',						'X*1e12');
									$insertFormula[]	= array('kilometre',						'micrometre',						'X*1e9');
									$insertFormula[]	= array('kilometre',						'millimetre',						'X*1e6');
									$insertFormula[]	= array('kilometre',						'centimetre',						'X*1e5');
									$insertFormula[]	= array('kilometre',						'metre',								'X*1e3');
									$insertFormula[]	= array('kilometre',						'inch',									'X/0.0254*1e3');
									$insertFormula[]	= array('kilometre',						'foot',									'X/0.3048*1e3');
									$insertFormula[]	= array('kilometre',						'yard',									'X/0.9144*1e3');
									$insertFormula[]	= array('kilometre',						'mile',									'X/1.609344');
									$insertFormula[]	= array('inch',									'nanometre',						'X*25.4e6');
									$insertFormula[]	= array('inch',									'micrometre',						'X*25.4e3');
									$insertFormula[]	= array('inch',									'millimetre',						'X*25.4');
									$insertFormula[]	= array('inch',									'centimetre',						'X*2.54');
									$insertFormula[]	= array('inch',									'metre',								'X*0.0254');
									$insertFormula[]	= array('inch',									'kilometre',						'X*0.0254/1e3');
									$insertFormula[]	= array('inch',									'foot',									'X/12');
									$insertFormula[]	= array('inch',									'yard',									'X/36');
									$insertFormula[]	= array('inch',									'mile',									'X/63360');
									$insertFormula[]	= array('foot',									'nanometre',						'X*304.8e6');
									$insertFormula[]	= array('foot',									'micrometre',						'X*304.8e3');
									$insertFormula[]	= array('foot',									'millimetre',						'X*304.8');
									$insertFormula[]	= array('foot',									'centimetre',						'X*30.48');
									$insertFormula[]	= array('foot',									'metre',								'X*0.3048');
									$insertFormula[]	= array('foot',									'kilometre',						'X*0.3048/1e3');
									$insertFormula[]	= array('foot',									'inch',									'X*12');
									$insertFormula[]	= array('foot',									'yard',									'X/3');
									$insertFormula[]	= array('foot',									'mile',									'X/5280');
									$insertFormula[]	= array('yard',									'nanometre',						'X*914.4e6');
									$insertFormula[]	= array('yard',									'micrometre',						'X*914.4e3');
									$insertFormula[]	= array('yard',									'millimetre',						'X*914.4');
									$insertFormula[]	= array('yard',									'centimetre',						'X*91.44');
									$insertFormula[]	= array('yard',									'metre',								'X*0.9144');
									$insertFormula[]	= array('yard',									'kilometre',						'X*0.9144/1e3');
									$insertFormula[]	= array('yard',									'inch',									'X*36');
									$insertFormula[]	= array('yard',									'foot',									'X*3');
									$insertFormula[]	= array('yard',									'mile',									'X/1760');
									$insertFormula[]	= array('mile',									'nanometre',						'X*1609344e6');
									$insertFormula[]	= array('mile',									'micrometre',						'X*1609344e3');
									$insertFormula[]	= array('mile',									'millimetre',						'X*1609344');
									$insertFormula[]	= array('mile',									'centimetre',						'X*160934.4');
									$insertFormula[]	= array('mile',									'metre',								'X*1609.344');
									$insertFormula[]	= array('mile',									'kilometre',						'X*1.609344');
									$insertFormula[]	= array('mile',									'inch',									'X*63360');
									$insertFormula[]	= array('mile',									'foot',									'X*5280');
									$insertFormula[]	= array('mile',									'yard',									'X*1760');
									break;
								case 3:
									$textName = 'Mass';
									$textValue = $checkMass;
									$insertGroup[]		= array('Mass',									'Masse');
									$insertUnit[]			= array('milligram',						'milligram',						'mg');
									$insertUnit[]			= array('gram',									'gram',									'g');
									$insertUnit[]			= array('kilogram',							'kilogram',							'kg');
									$insertUnit[]			= array('ounce (avoirdupois)',	'ounce (avoirdupois)',	'oz');
									$insertUnit[]			= array('ounce (troy)',					'ounce (troy)',					'oz');
									$insertUnit[]			= array('pound (avoirdupois)',	'pound (avoirdupois)',	'lb');
									$insertUnit[]			= array('pound (troy)',					'pound (troy)',					'lb');
									$insertUnit[]			= array('tonne (metric ton)',		'tonne (metric ton)',		't');
									$insertUnit[]			= array('ton (long UK)',				'ton (long UK)',				'tn');
									$insertUnit[]			= array('ton (short US)',				'ton (short US)',				'tn');

									$insertFormula[]	= array('milligram',						'gram',									'X/1e3');
									$insertFormula[]	= array('milligram',						'kilogram',							'X/1e6');
									$insertFormula[]	= array('milligram',						'ounce (avoirdupois)',	'X/28349.525');
									$insertFormula[]	= array('milligram',						'ounce (troy)',					'X/31103.475');
									$insertFormula[]	= array('milligram',						'pound (avoirdupois)',	'X/453592.4');
									$insertFormula[]	= array('milligram',						'pound (troy)',					'X/373241.7');
									$insertFormula[]	= array('milligram',						'tonne (metric ton)',		'X/1e9');
									$insertFormula[]	= array('milligram',						'ton (long UK)',				'X/453592.4/2240');
									$insertFormula[]	= array('milligram',						'ton (short US)',				'X/453592.4/2000');
									$insertFormula[]	= array('gram',									'milligram',						'X*1e3');
									$insertFormula[]	= array('gram',									'kilogram',							'X/1e3');
									$insertFormula[]	= array('gram',									'ounce (avoirdupois)',	'X/28.349525');
									$insertFormula[]	= array('gram',									'ounce (troy)',					'X/31.103475');
									$insertFormula[]	= array('gram',									'pound (avoirdupois)',	'X/453.5924');
									$insertFormula[]	= array('gram',									'pound (troy)',					'X/373.2417');
									$insertFormula[]	= array('gram',									'tonne (metric ton)',		'X/1e6');
									$insertFormula[]	= array('gram',									'ton (long UK)',				'X/453.5924/2240');
									$insertFormula[]	= array('gram',									'ton (short US)',				'X/453.5924/2000');
									$insertFormula[]	= array('kilogram',							'milligram',						'X*1e6');
									$insertFormula[]	= array('kilogram',							'gram',									'X*1e3');
									$insertFormula[]	= array('kilogram',							'ounce (avoirdupois)',	'X/0.028349525');
									$insertFormula[]	= array('kilogram',							'ounce (troy)',					'X/0.031103475');
									$insertFormula[]	= array('kilogram',							'pound (avoirdupois)',	'X/0.4535924');
									$insertFormula[]	= array('kilogram',							'pound (troy)',					'X/0.3732417');
									$insertFormula[]	= array('kilogram',							'tonne (metric ton)',		'X/1e3');
									$insertFormula[]	= array('kilogram',							'ton (long UK)',				'X/0.4535924/2240');
									$insertFormula[]	= array('kilogram',							'ton (short US)',				'X/0.4535924/2000');
									$insertFormula[]	= array('ounce (avoirdupois)',	'milligram',						'X*28349.525');
									$insertFormula[]	= array('ounce (avoirdupois)',	'gram',									'X*28.349525');
									$insertFormula[]	= array('ounce (avoirdupois)',	'kilogram',							'X*0.028349525');
									$insertFormula[]	= array('ounce (avoirdupois)',	'ounce (troy)',					'X*0.4535924/0.3732417/16*12');
									$insertFormula[]	= array('ounce (avoirdupois)',	'pound (avoirdupois)',	'X/16');
									$insertFormula[]	= array('ounce (avoirdupois)',	'pound (troy)',					'X*0.4535924/0.3732417/16');
									$insertFormula[]	= array('ounce (avoirdupois)',	'tonne (metric ton)',		'X*0.028349525/1e3');
									$insertFormula[]	= array('ounce (avoirdupois)',	'ton (long UK)',				'X/35840');
									$insertFormula[]	= array('ounce (avoirdupois)',	'ton (short US)',				'X/32000');
									$insertFormula[]	= array('ounce (troy)',					'milligram',						'X*31103.475');
									$insertFormula[]	= array('ounce (troy)',					'gram',									'X*31.103475');
									$insertFormula[]	= array('ounce (troy)',					'kilogram',							'X*0.031103475');
									$insertFormula[]	= array('ounce (troy)',					'ounce (avoirdupois)',	'X/0.4535924*0.3732417/12*16');
									$insertFormula[]	= array('ounce (troy)',					'pound (avoirdupois)',	'X/0.4535924*0.3732417/12');
									$insertFormula[]	= array('ounce (troy)',					'pound (troy)',					'X/12');
									$insertFormula[]	= array('ounce (troy)',					'tonne (metric ton)',		'X*0.03110348/1e3');
									$insertFormula[]	= array('ounce (troy)',					'ton (long UK)',				'X/0.4535924*0.3732417/26880');
									$insertFormula[]	= array('ounce (troy)',					'ton (short US)',				'X/0.4535924*0.3732417/24000');
									$insertFormula[]	= array('pound (avoirdupois)',	'milligram',						'X*453592.4');
									$insertFormula[]	= array('pound (avoirdupois)',	'gram',									'X*453.5924');
									$insertFormula[]	= array('pound (avoirdupois)',	'kilogram',							'X*0.4535924');
									$insertFormula[]	= array('pound (avoirdupois)',	'ounce (avoirdupois)',	'X*16');
									$insertFormula[]	= array('pound (avoirdupois)',	'ounce (troy)',					'X*0.4535924/0.3732417*12');
									$insertFormula[]	= array('pound (avoirdupois)',	'pound (troy)',					'X*0.4535924/0.3732417');
									$insertFormula[]	= array('pound (avoirdupois)',	'tonne (metric ton)',		'X*0.4535924/1e3');
									$insertFormula[]	= array('pound (avoirdupois)',	'ton (long UK)',				'X/2240');
									$insertFormula[]	= array('pound (avoirdupois)',	'ton (short US)',				'X/2000');
									$insertFormula[]	= array('pound (troy)',					'milligram',						'X*373241.7');
									$insertFormula[]	= array('pound (troy)',					'gram',									'X*373.2417');
									$insertFormula[]	= array('pound (troy)',					'kilogram',							'X*0.3732417');
									$insertFormula[]	= array('pound (troy)',					'ounce (avoirdupois)',	'X/0.4535924*0.3732417*16');
									$insertFormula[]	= array('pound (troy)',					'ounce (troy)',					'X*12');
									$insertFormula[]	= array('pound (troy)',					'pound (avoirdupois)',	'X/0.4535924*0.3732417');
									$insertFormula[]	= array('pound (troy)',					'tonne (metric ton)',		'X*0.3732417/1e3');
									$insertFormula[]	= array('pound (troy)',					'ton (long UK)',				'X/0.4535924*0.3732417/2240');
									$insertFormula[]	= array('pound (troy)',					'ton (short US)',				'X/0.4535924*0.3732417/2000');
									$insertFormula[]	= array('tonne (metric ton)',		'milligram',						'X*1e9');
									$insertFormula[]	= array('tonne (metric ton)',		'gram',									'X*1e6');
									$insertFormula[]	= array('tonne (metric ton)',		'kilogram',							'X*1e3');
									$insertFormula[]	= array('tonne (metric ton)',		'ounce (avoirdupois)',	'X/0.028349525*1e3');
									$insertFormula[]	= array('tonne (metric ton)',		'ounce (troy)',					'X/0.03110348*1e3');
									$insertFormula[]	= array('tonne (metric ton)',		'pound (avoirdupois)',	'X/0.4535924*1e3');
									$insertFormula[]	= array('tonne (metric ton)',		'pound (troy)',					'X/0.3732417*1e3');
									$insertFormula[]	= array('tonne (metric ton)',		'ton (long UK)',				'X/0.4535924*1e3/2240');
									$insertFormula[]	= array('tonne (metric ton)',		'ton (short US)',				'X/0.4535924*1e3/2000');
									$insertFormula[]	= array('ton (long UK)',				'milligram',						'X*453592.4*2240');
									$insertFormula[]	= array('ton (long UK)',				'gram',									'X*453.5924*2240');
									$insertFormula[]	= array('ton (long UK)',				'kilogram',							'X*0.4535924*2240');
									$insertFormula[]	= array('ton (long UK)',				'ounce (avoirdupois)',	'X*35840');
									$insertFormula[]	= array('ton (long UK)',				'ounce (troy)',					'X*0.4535924/0.3732417*26880');
									$insertFormula[]	= array('ton (long UK)',				'pound (avoirdupois)',	'X*2240');
									$insertFormula[]	= array('ton (long UK)',				'pound (troy)',					'X*0.4535924/0.3732417*2240');
									$insertFormula[]	= array('ton (long UK)',				'tonne (metric ton)',		'X*0.4535924/1e3*2240');
									$insertFormula[]	= array('ton (long UK)',				'ton (short US)',				'X*1.12');
									$insertFormula[]	= array('ton (short US)',				'milligram',						'X*453592.4*2000');
									$insertFormula[]	= array('ton (short US)',				'gram',									'X*453.5924*2000');
									$insertFormula[]	= array('ton (short US)',				'kilogram',							'X*0.4535924*2000');
									$insertFormula[]	= array('ton (short US)',				'ounce (avoirdupois)',	'X*32000');
									$insertFormula[]	= array('ton (short US)',				'ounce (troy)',					'X*0.4535924/0.3732417*24000');
									$insertFormula[]	= array('ton (short US)',				'pound (avoirdupois)',	'X*2000');
									$insertFormula[]	= array('ton (short US)',				'pound (troy)',					'X*0.4535924/0.3732417*2000');
									$insertFormula[]	= array('ton (short US)',				'tonne (metric ton)',		'X*0.4535924/1e3*2000');
									$insertFormula[]	= array('ton (short US)',				'ton (long UK)',				'X/1.12');
									break;
								case 4:
									$textName = 'Power';
									$textValue = $checkPower;
									$insertGroup[]		= array('Power',								'Leistung');
									$insertUnit[]			= array('watt',									'watt',									'W');
									$insertUnit[]			= array('kilowatt',							'kilowatt',							'kW');
									$insertUnit[]			= array('horsepower',						'horsepower',						'hp');
									$insertUnit[]			= array('horsepower (metric)',	'horsepower (metric)',	'hp');

									$insertFormula[]	= array('watt',									'kilowatt',							'X/1e3');
									$insertFormula[]	= array('watt',									'horsepower',						'X/745.7');
									$insertFormula[]	= array('watt',									'horsepower (metric)',	'X/735.499');
									$insertFormula[]	= array('kilowatt',							'watt',									'X*1e3');
									$insertFormula[]	= array('kilowatt',							'horsepower',						'X*1e3/745.7');
									$insertFormula[]	= array('kilowatt',							'horsepower (metric)',	'X*1e3/735.499');
									$insertFormula[]	= array('horsepower',						'watt',									'X*745.7');
									$insertFormula[]	= array('horsepower',						'kilowatt',							'X*745.7/1e3');
									$insertFormula[]	= array('horsepower',						'horsepower (metric)',	'X*1.01387');
									$insertFormula[]	= array('horsepower (metric)',	'watt',									'X*735.499');
									$insertFormula[]	= array('horsepower (metric)',	'kilowatt',							'X*735.499/1e3');
									$insertFormula[]	= array('horsepower (metric)',	'horsepower',						'X/1.01387');
									break;
								case 5:
									$textName = 'Pressure';
									$textValue = $checkPressure;
									$insertGroup[]		= array('Pressure',							'Druck');
									$insertUnit[]			= array('pascal',								'pascal',								'Pa');
									$insertUnit[]			= array('kilopascal',						'kilopascal',						'kPa');
									$insertUnit[]			= array('megapascal',						'megapascal',						'MPa');
									$insertUnit[]			= array('bar',									'bar',									'bar');
									$insertUnit[]			= array('torr',									'torr',									'torr');
									$insertUnit[]			= array('atmosphere',						'atmosphere',						'atm');
									$insertUnit[]			= array('millimetre mercury',		'millimetre mercury',		'mmHg');
									$insertUnit[]			= array('inch mercury',					'inch mercury',					'inHg');

									$insertFormula[]	= array('pascal',								'kilopascal',						'X/1e3');
									$insertFormula[]	= array('pascal',								'megapascal',						'X/1e6');
									$insertFormula[]	= array('pascal',								'bar',									'X/1e5');
									$insertFormula[]	= array('pascal',								'torr',									'X/133.3224');
									$insertFormula[]	= array('pascal',								'atmosphere',						'X/101325');
									$insertFormula[]	= array('pascal',								'millimetre mercury',		'X/133.3224');
									$insertFormula[]	= array('pascal',								'inch mercury',					'X/3386.389');
									$insertFormula[]	= array('kilopascal',						'pascal',								'X*1e3');
									$insertFormula[]	= array('kilopascal',						'megapascal',						'X/1e3');
									$insertFormula[]	= array('kilopascal',						'bar',									'X/100');
									$insertFormula[]	= array('kilopascal',						'torr',									'X/0.1333224');
									$insertFormula[]	= array('kilopascal',						'atmosphere',						'X/101.325');
									$insertFormula[]	= array('kilopascal',						'millimetre mercury',		'X/0.1333224');
									$insertFormula[]	= array('kilopascal',						'inch mercury',					'X/3.386389');
									$insertFormula[]	= array('megapascal',						'pascal',								'X*1e6');
									$insertFormula[]	= array('megapascal',						'kilopascal',						'X*1e3');
									$insertFormula[]	= array('megapascal',						'bar',									'X*10');
									$insertFormula[]	= array('megapascal',						'torr',									'X/1.333224*1e4');
									$insertFormula[]	= array('megapascal',						'atmosphere',						'X/0.101325');
									$insertFormula[]	= array('megapascal',						'millimetre mercury',		'X/1.333224*1e4');
									$insertFormula[]	= array('megapascal',						'inch mercury',					'X/3.386389*1e3');
									$insertFormula[]	= array('bar',									'pascal',								'X*1e5');
									$insertFormula[]	= array('bar',									'kilopascal',						'X*100');
									$insertFormula[]	= array('bar',									'megapascal',						'X/10');
									$insertFormula[]	= array('bar',									'torr',									'X/1.333224*1e3');
									$insertFormula[]	= array('bar',									'atmosphere',						'X/1.01325');
									$insertFormula[]	= array('bar',									'millimetre mercury',		'X/1.333224*1e3');
									$insertFormula[]	= array('bar',									'inch mercury',					'X/3.386389*100');
									$insertFormula[]	= array('torr',									'pascal',								'X*133.3224');
									$insertFormula[]	= array('torr',									'kilopascal',						'X*0.1333224');
									$insertFormula[]	= array('torr',									'megapascal',						'X*1.333224/1e4');
									$insertFormula[]	= array('torr',									'bar',									'X*1.333224/1e3');
									$insertFormula[]	= array('torr',									'atmosphere',						'X/760');
									$insertFormula[]	= array('torr',									'millimetre mercury',		'X');
									$insertFormula[]	= array('torr',									'inch mercury',					'X/25.4');
									$insertFormula[]	= array('atmosphere',						'pascal',								'X*101325');
									$insertFormula[]	= array('atmosphere',						'kilopascal',						'X*101.325');
									$insertFormula[]	= array('atmosphere',						'megapascal',						'X*0.101325');
									$insertFormula[]	= array('atmosphere',						'bar',									'X*1.01325');
									$insertFormula[]	= array('atmosphere',						'torr',									'X*760');
									$insertFormula[]	= array('atmosphere',						'millimetre mercury',		'X*760');
									$insertFormula[]	= array('atmosphere',						'inch mercury',					'X*760/25.4');
									$insertFormula[]	= array('millimetre mercury',		'pascal',								'X*133.3224');
									$insertFormula[]	= array('millimetre mercury',		'kilopascal',						'X*0.1333224');
									$insertFormula[]	= array('millimetre mercury',		'megapascal',						'X*1.333224/1e4');
									$insertFormula[]	= array('millimetre mercury',		'bar',									'X*1.333224/1e3');
									$insertFormula[]	= array('millimetre mercury',		'torr',									'X');
									$insertFormula[]	= array('millimetre mercury',		'atmosphere',						'X/760');
									$insertFormula[]	= array('millimetre mercury',		'inch mercury',					'X/25.4');
									$insertFormula[]	= array('inch mercury',					'pascal',								'X*3386.389');
									$insertFormula[]	= array('inch mercury',					'kilopascal',						'X*3.386389');
									$insertFormula[]	= array('inch mercury',					'megapascal',						'X*3.386389/1e3');
									$insertFormula[]	= array('inch mercury',					'bar',									'X*3.386389/100');
									$insertFormula[]	= array('inch mercury',					'torr',									'X*25.4');
									$insertFormula[]	= array('inch mercury',					'atmosphere',						'X/760*25.4');
									$insertFormula[]	= array('inch mercury',					'millimetre mercury',		'X*25.4');
									break;
								case 6:
									$textName = 'Speed';
									$textValue = $checkSpeed;
									$insertGroup[]		= array('Speed',								'Geschwindigkeit');
									$insertUnit[]			= array('metre per second',			'metre per second',			'm/s');
									$insertUnit[]			= array('kilometre per hour',		'kilometre per hour',		'km/h');
									$insertUnit[]			= array('inch per second',			'inch per second',			'in/s');
									$insertUnit[]			= array('inch per minute',			'inch per minute',			'in/min');
									$insertUnit[]			= array('foot per second',			'foot per second',			'ft/s');
									$insertUnit[]			= array('foot per minute',			'foot per minute',			'ft/min');
									$insertUnit[]			= array('mile per hour (MPH)',	'mile per hour (MPH)',	'mi/h');

									$insertFormula[]	= array('metre per second',			'kilometre per hour',		'X*3.6');
									$insertFormula[]	= array('metre per second',			'inch per second',			'X/0.0254');
									$insertFormula[]	= array('metre per second',			'inch per minute',			'X/0.0254*60');
									$insertFormula[]	= array('metre per second',			'foot per second',			'X/0.3048');
									$insertFormula[]	= array('metre per second',			'foot per minute',			'X/0.3048*60');
									$insertFormula[]	= array('metre per second',			'mile per hour (MPH)',	'X/1609.344*3600');
									$insertFormula[]	= array('kilometre per hour',		'metre per second',			'X/3.6');
									$insertFormula[]	= array('kilometre per hour',		'inch per second',			'X/3.6/0.0254');
									$insertFormula[]	= array('kilometre per hour',		'inch per minute',			'X/3.6/0.0254*60');
									$insertFormula[]	= array('kilometre per hour',		'foot per second',			'X/3.6/0.3048');
									$insertFormula[]	= array('kilometre per hour',		'foot per minute',			'X/3.6/0.3048*60');
									$insertFormula[]	= array('kilometre per hour',		'mile per hour (MPH)',	'X/1.609344');
									$insertFormula[]	= array('inch per second',			'metre per second',			'X*0.0254');
									$insertFormula[]	= array('inch per second',			'kilometre per hour',		'X*3.6*0.0254');
									$insertFormula[]	= array('inch per second',			'inch per minute',			'X*60');
									$insertFormula[]	= array('inch per second',			'foot per second',			'X/12');
									$insertFormula[]	= array('inch per second',			'foot per minute',			'X*5');
									$insertFormula[]	= array('inch per second',			'mile per hour (MPH)',	'X/17.6');
									$insertFormula[]	= array('inch per minute',			'metre per second',			'X*0.0254/60');
									$insertFormula[]	= array('inch per minute',			'kilometre per hour',		'X*3.6*0.0254/60');
									$insertFormula[]	= array('inch per minute',			'inch per second',			'X/60');
									$insertFormula[]	= array('inch per minute',			'foot per second',			'X*5');
									$insertFormula[]	= array('inch per minute',			'foot per minute',			'X/12');
									$insertFormula[]	= array('inch per minute',			'mile per hour (MPH)',	'X/1056');
									$insertFormula[]	= array('foot per second',			'metre per second',			'X*0.3048');
									$insertFormula[]	= array('foot per second',			'kilometre per hour',		'X*3.6*0.3048');
									$insertFormula[]	= array('foot per second',			'inch per second',			'X*12');
									$insertFormula[]	= array('foot per second',			'inch per minute',			'X/5');
									$insertFormula[]	= array('foot per second',			'foot per minute',			'X*60');
									$insertFormula[]	= array('foot per second',			'mile per hour (MPH)',	'X/5280*3600');
									$insertFormula[]	= array('foot per minute',			'metre per second',			'X*0.3048/60');
									$insertFormula[]	= array('foot per minute',			'kilometre per hour',		'X*3.6*0.3048/60');
									$insertFormula[]	= array('foot per minute',			'inch per second',			'X/5');
									$insertFormula[]	= array('foot per minute',			'inch per minute',			'X*12');
									$insertFormula[]	= array('foot per minute',			'foot per second',			'X/60');
									$insertFormula[]	= array('foot per minute',			'mile per hour (MPH)',	'X/88');
									$insertFormula[]	= array('mile per hour (MPH)',	'metre per second',			'X*1609.344/3600');
									$insertFormula[]	= array('mile per hour (MPH)',	'kilometre per hour',		'X*1.609344');
									$insertFormula[]	= array('mile per hour (MPH)',	'inch per second',			'X*17.6');
									$insertFormula[]	= array('mile per hour (MPH)',	'inch per minute',			'X*1056');
									$insertFormula[]	= array('mile per hour (MPH)',	'foot per second',			'X*5280/3600');
									$insertFormula[]	= array('mile per hour (MPH)',	'foot per minute',			'X*88');
									break;
								case 7:
									$textName = 'Temperature';
									$textValue = $checkTemperature;
									$insertGroup[]		= array('Temperature',					'Temperatur');
									$insertUnit[]			= array('kelvin',								'kelvin',								'K');
									$insertUnit[]			= array('celsius',							'celsius',							'C');
									$insertUnit[]			= array('fahrenheit',						'fahrenheit',						'F');

									$insertFormula[]	= array('kelvin',								'celsius',							'X-273.15');
									$insertFormula[]	= array('kelvin',								'fahrenheit',						'X*(9/5)-459.67');
									$insertFormula[]	= array('celsius',							'kelvin',								'X+273.15');
									$insertFormula[]	= array('celsius',							'fahrenheit',						'X*(9/5)+32');
									$insertFormula[]	= array('fahrenheit',						'kelvin',								'(X+459.67)*(5/9)');
									$insertFormula[]	= array('fahrenheit',						'celsius',							'(X-32)*(5/9)');
									break;
								case 8:
									$textName = 'Volume';
									$textValue = $checkVolume;
									$insertGroup[]		= array('Volume',								'Volumen');
									$insertUnit[]			= array('cubic millimetre',			'cubic millimetre',			'mm3');
									$insertUnit[]			= array('cubic centimetre',			'cubic centimetre',			'cm3');
									$insertUnit[]			= array('cubic decimetre',			'cubic decimetre',			'dm3');
									$insertUnit[]			= array('cubic metre',					'cubic metre',					'm3');
									$insertUnit[]			= array('cubic kilometre',			'cubic kilometre',			'km3');
									$insertUnit[]			= array('cubic inch',						'cubic inch',						'in3');
									$insertUnit[]			= array('cubic foot',						'cubic foot',						'ft3');
									$insertUnit[]			= array('cubic yard',						'cubic yard',						'yd3');
									$insertUnit[]			= array('cubic mile',						'cubic mile',						'mi3');
									$insertUnit[]			= array('millilitre',						'millilitre',						'ml');
									$insertUnit[]			= array('centilitre',						'centilitre',						'cl');
									$insertUnit[]			= array('litre',								'litre',								'l');
									$insertUnit[]			= array('hectolitre',						'hectolitre',						'hl');

									$insertFormula[]	= array('cubic millimetre',			'cubic centimetre',			'X/1e3');
									$insertFormula[]	= array('cubic millimetre',			'cubic decimetre',			'X/1e6');
									$insertFormula[]	= array('cubic millimetre',			'cubic metre',					'X/1e9');
									$insertFormula[]	= array('cubic millimetre',			'cubic kilometre',			'X/1e18');
									$insertFormula[]	= array('cubic millimetre',			'cubic inch',						'X/16387.064');
									$insertFormula[]	= array('cubic millimetre',			'cubic foot',						'X/28316846.592');
									$insertFormula[]	= array('cubic millimetre',			'cubic yard',						'X/764554857.984');
									$insertFormula[]	= array('cubic millimetre',			'cubic mile',						'X/4168181825440579584');
									$insertFormula[]	= array('cubic millimetre',			'millilitre',						'X/1e3');
									$insertFormula[]	= array('cubic millimetre',			'centilitre',						'X/1e4');
									$insertFormula[]	= array('cubic millimetre',			'litre',								'X/1e6');
									$insertFormula[]	= array('cubic millimetre',			'hectolitre',						'X/1e8');
									$insertFormula[]	= array('cubic centimetre',			'cubic millimetre',			'X*1e3');
									$insertFormula[]	= array('cubic centimetre',			'cubic decimetre',			'X/1e3');
									$insertFormula[]	= array('cubic centimetre',			'cubic metre',					'X/1e6');
									$insertFormula[]	= array('cubic centimetre',			'cubic kilometre',			'X/1e15');
									$insertFormula[]	= array('cubic centimetre',			'cubic inch',						'X/16.387064');
									$insertFormula[]	= array('cubic centimetre',			'cubic foot',						'X/28316.846592');
									$insertFormula[]	= array('cubic centimetre',			'cubic yard',						'X/764554.857984');
									$insertFormula[]	= array('cubic centimetre',			'cubic mile',						'X/4168181825440579.584');
									$insertFormula[]	= array('cubic centimetre',			'millilitre',						'X');
									$insertFormula[]	= array('cubic centimetre',			'centilitre',						'X/10');
									$insertFormula[]	= array('cubic centimetre',			'litre',								'X/1e3');
									$insertFormula[]	= array('cubic centimetre',			'hectolitre',						'X/1e5');
									$insertFormula[]	= array('cubic decimetre',			'cubic millimetre',			'X*1e6');
									$insertFormula[]	= array('cubic decimetre',			'cubic centimetre',			'X*1e3');
									$insertFormula[]	= array('cubic decimetre',			'cubic metre',					'X/1e3');
									$insertFormula[]	= array('cubic decimetre',			'cubic kilometre',			'X/1e12');
									$insertFormula[]	= array('cubic decimetre',			'cubic inch',						'X/0.016387064');
									$insertFormula[]	= array('cubic decimetre',			'cubic foot',						'X/28.316846592');
									$insertFormula[]	= array('cubic decimetre',			'cubic yard',						'X/764.554857984');
									$insertFormula[]	= array('cubic decimetre',			'cubic mile',						'X/4168181825440.579584');
									$insertFormula[]	= array('cubic decimetre',			'millilitre',						'X*1e3');
									$insertFormula[]	= array('cubic decimetre',			'centilitre',						'X*100');
									$insertFormula[]	= array('cubic decimetre',			'litre',								'X');
									$insertFormula[]	= array('cubic decimetre',			'hectolitre',						'X/100');
									$insertFormula[]	= array('cubic metre',					'cubic millimetre',			'X*1e9');
									$insertFormula[]	= array('cubic metre',					'cubic centimetre',			'X*1e6');
									$insertFormula[]	= array('cubic metre',					'cubic decimetre',			'X*1e3');
									$insertFormula[]	= array('cubic metre',					'cubic kilometre',			'X/1e9');
									$insertFormula[]	= array('cubic metre',					'cubic inch',						'X/16.387064*1e6');
									$insertFormula[]	= array('cubic metre',					'cubic foot',						'X/0.028316846592');
									$insertFormula[]	= array('cubic metre',					'cubic yard',						'X/0.764554857984');
									$insertFormula[]	= array('cubic metre',					'cubic mile',						'X/4168181825.440579584');
									$insertFormula[]	= array('cubic metre',					'millilitre',						'X*1e6');
									$insertFormula[]	= array('cubic metre',					'centilitre',						'X*1e5');
									$insertFormula[]	= array('cubic metre',					'litre',								'X*1e3');
									$insertFormula[]	= array('cubic metre',					'hectolitre',						'X*10');
									$insertFormula[]	= array('cubic kilometre',			'cubic millimetre',			'X*1e18');
									$insertFormula[]	= array('cubic kilometre',			'cubic centimetre',			'X*1e15');
									$insertFormula[]	= array('cubic kilometre',			'cubic decimetre',			'X*1e12');
									$insertFormula[]	= array('cubic kilometre',			'cubic metre',					'X*1e9');
									$insertFormula[]	= array('cubic kilometre',			'cubic inch',						'X/1.6387064*1e14');
									$insertFormula[]	= array('cubic kilometre',			'cubic foot',						'X/2.8316846592*1e11');
									$insertFormula[]	= array('cubic kilometre',			'cubic yard',						'X/7.64554857984*1e10');
									$insertFormula[]	= array('cubic kilometre',			'cubic mile',						'X/4.168181825440579584');
									$insertFormula[]	= array('cubic kilometre',			'millilitre',						'X*1e15');
									$insertFormula[]	= array('cubic kilometre',			'centilitre',						'X*1e14');
									$insertFormula[]	= array('cubic kilometre',			'litre',								'X*1e12');
									$insertFormula[]	= array('cubic kilometre',			'hectolitre',						'X*1e10');
									$insertFormula[]	= array('cubic inch',						'cubic millimetre',			'X*16387.064');
									$insertFormula[]	= array('cubic inch',						'cubic centimetre',			'X*16.387064');
									$insertFormula[]	= array('cubic inch',						'cubic decimetre',			'X*0.016387064');
									$insertFormula[]	= array('cubic inch',						'cubic metre',					'X*16.387064/1e6');
									$insertFormula[]	= array('cubic inch',						'cubic kilometre',			'X*1.6387064/1e14');
									$insertFormula[]	= array('cubic inch',						'cubic foot',						'X/1728');
									$insertFormula[]	= array('cubic inch',						'cubic yard',						'X/46656');
									$insertFormula[]	= array('cubic inch',						'cubic mile',						'X/254358061056000');
									$insertFormula[]	= array('cubic inch',						'millilitre',						'X*16.387064');
									$insertFormula[]	= array('cubic inch',						'centilitre',						'X*1.6387064');
									$insertFormula[]	= array('cubic inch',						'litre',								'X*0.016387064');
									$insertFormula[]	= array('cubic inch',						'hectolitre',						'X*1.6387064/1e4');
									$insertFormula[]	= array('cubic foot',						'cubic millimetre',			'X*28316846.592');
									$insertFormula[]	= array('cubic foot',						'cubic centimetre',			'X*28316.846592');
									$insertFormula[]	= array('cubic foot',						'cubic decimetre',			'X*28.316846592');
									$insertFormula[]	= array('cubic foot',						'cubic metre',					'X*0.028316846592');
									$insertFormula[]	= array('cubic foot',						'cubic kilometre',			'X*2.8316846592/1e11');
									$insertFormula[]	= array('cubic foot',						'cubic inch',						'X*1728');
									$insertFormula[]	= array('cubic foot',						'cubic yard',						'X/27');
									$insertFormula[]	= array('cubic foot',						'cubic mile',						'X/147197952000');
									$insertFormula[]	= array('cubic foot',						'millilitre',						'X*28316.846592');
									$insertFormula[]	= array('cubic foot',						'centilitre',						'X*2831.6846592');
									$insertFormula[]	= array('cubic foot',						'litre',								'X*28.316846592');
									$insertFormula[]	= array('cubic foot',						'hectolitre',						'X*0.28316846592');
									$insertFormula[]	= array('cubic yard',						'cubic millimetre',			'X*764554857.984');
									$insertFormula[]	= array('cubic yard',						'cubic centimetre',			'X*764554.857984');
									$insertFormula[]	= array('cubic yard',						'cubic decimetre',			'X*764.554857984');
									$insertFormula[]	= array('cubic yard',						'cubic metre',					'X*0.764554857984');
									$insertFormula[]	= array('cubic yard',						'cubic kilometre',			'X*7.64554857984/1e10');
									$insertFormula[]	= array('cubic yard',						'cubic inch',						'X*46656');
									$insertFormula[]	= array('cubic yard',						'cubic foot',						'X*27');
									$insertFormula[]	= array('cubic yard',						'cubic mile',						'X/5451776000');
									$insertFormula[]	= array('cubic yard',						'millilitre',						'X*764554.857984');
									$insertFormula[]	= array('cubic yard',						'centilitre',						'X*76455.4857984');
									$insertFormula[]	= array('cubic yard',						'litre',								'X*764.554857984');
									$insertFormula[]	= array('cubic yard',						'hectolitre',						'X*7.64554857984');
									$insertFormula[]	= array('cubic mile',						'cubic millimetre',			'X*4168181825440579584');
									$insertFormula[]	= array('cubic mile',						'cubic centimetre',			'X*4168181825440579.584');
									$insertFormula[]	= array('cubic mile',						'cubic decimetre',			'X*4168181825440.579584');
									$insertFormula[]	= array('cubic mile',						'cubic metre',					'X*4168181825.440579584');
									$insertFormula[]	= array('cubic mile',						'cubic kilometre',			'X*4.168181825440579584');
									$insertFormula[]	= array('cubic mile',						'cubic inch',						'X*254358061056000');
									$insertFormula[]	= array('cubic mile',						'cubic foot',						'X*147197952000');
									$insertFormula[]	= array('cubic mile',						'cubic yard',						'X*5451776000');
									$insertFormula[]	= array('cubic mile',						'millilitre',						'X*4168181825440579.584');
									$insertFormula[]	= array('cubic mile',						'centilitre',						'X*416818182544057.9584');
									$insertFormula[]	= array('cubic mile',						'litre',								'X*4168181825440.579584');
									$insertFormula[]	= array('cubic mile',						'hectolitre',						'X*41681818254.40579584');
									$insertFormula[]	= array('millilitre',						'cubic millimetre',			'X*1e3');
									$insertFormula[]	= array('millilitre',						'cubic centimetre',			'X');
									$insertFormula[]	= array('millilitre',						'cubic decimetre',			'X/1e3');
									$insertFormula[]	= array('millilitre',						'cubic metre',					'X/1e6');
									$insertFormula[]	= array('millilitre',						'cubic kilometre',			'X/1e15');
									$insertFormula[]	= array('millilitre',						'cubic inch',						'X/16.387064');
									$insertFormula[]	= array('millilitre',						'cubic foot',						'X/28316.846592');
									$insertFormula[]	= array('millilitre',						'cubic yard',						'X/764554.857984');
									$insertFormula[]	= array('millilitre',						'cubic mile',						'X/4168181825440579.584');
									$insertFormula[]	= array('millilitre',						'centilitre',						'X/10');
									$insertFormula[]	= array('millilitre',						'litre',								'X/1e3');
									$insertFormula[]	= array('millilitre',						'hectolitre',						'X/1e5');
									$insertFormula[]	= array('centilitre',						'cubic millimetre',			'X*1e4');
									$insertFormula[]	= array('centilitre',						'cubic centimetre',			'X*10');
									$insertFormula[]	= array('centilitre',						'cubic decimetre',			'X/100');
									$insertFormula[]	= array('centilitre',						'cubic metre',					'X/1e5');
									$insertFormula[]	= array('centilitre',						'cubic kilometre',			'X/1e14');
									$insertFormula[]	= array('centilitre',						'cubic inch',						'X/1.6387064');
									$insertFormula[]	= array('centilitre',						'cubic foot',						'X/2831.6846592');
									$insertFormula[]	= array('centilitre',						'cubic yard',						'X/76455.4857984');
									$insertFormula[]	= array('centilitre',						'cubic mile',						'X/416818182544057.9584');
									$insertFormula[]	= array('centilitre',						'millilitre',						'X*10');
									$insertFormula[]	= array('centilitre',						'litre',								'X/100');
									$insertFormula[]	= array('centilitre',						'hectolitre',						'X/1e4');
									$insertFormula[]	= array('litre',								'cubic millimetre',			'X*1e6');
									$insertFormula[]	= array('litre',								'cubic centimetre',			'X*1e3');
									$insertFormula[]	= array('litre',								'cubic decimetre',			'X');
									$insertFormula[]	= array('litre',								'cubic metre',					'X/1e3');
									$insertFormula[]	= array('litre',								'cubic kilometre',			'X/1e12');
									$insertFormula[]	= array('litre',								'cubic inch',						'X/0.016387064');
									$insertFormula[]	= array('litre',								'cubic foot',						'X/28.316846592');
									$insertFormula[]	= array('litre',								'cubic yard',						'X/764.554857984');
									$insertFormula[]	= array('litre',								'cubic mile',						'X/4168181825440.579584');
									$insertFormula[]	= array('litre',								'millilitre',						'X*1e3');
									$insertFormula[]	= array('litre',								'centilitre',						'X*100');
									$insertFormula[]	= array('litre',								'hectolitre',						'X/100');
									$insertFormula[]	= array('hectolitre',						'cubic millimetre',			'X*1e8');
									$insertFormula[]	= array('hectolitre',						'cubic centimetre',			'X*1e5');
									$insertFormula[]	= array('hectolitre',						'cubic decimetre',			'X*100');
									$insertFormula[]	= array('hectolitre',						'cubic metre',					'X/10');
									$insertFormula[]	= array('hectolitre',						'cubic kilometre',			'X/1e10');
									$insertFormula[]	= array('hectolitre',						'cubic inch',						'X/1.6387064*1e4');
									$insertFormula[]	= array('hectolitre',						'cubic foot',						'X/0.28316846592');
									$insertFormula[]	= array('hectolitre',						'cubic yard',						'X/7.64554857984');
									$insertFormula[]	= array('hectolitre',						'cubic mile',						'X/41681818254.40579584');
									$insertFormula[]	= array('hectolitre',						'millilitre',						'X*1e5');
									$insertFormula[]	= array('hectolitre',						'centilitre',						'X*1e4');
									$insertFormula[]	= array('hectolitre',						'litre',								'X*100');
									break;
							}
	
							if ($textValue == 1) {
				 				$query = "SELECT uid FROM tx_cs2unitconverter_groups WHERE group_name = '".$GLOBALS['TYPO3_DB']->quoteStr($textName,'')."'";
				 				$res = mysql(TYPO3_db, $query);
								if ($res != '') {
									if (mysql_num_rows($res) > 0) {
										$groups_uid = array();
										while ($row = mysql_fetch_assoc($res))
											$groups_uid[] = intval($row['uid']);
						 				$query = "SELECT uid FROM tx_cs2unitconverter_units WHERE group_uid in (".implode(',',$groups_uid).")";
						 				$res2 = mysql(TYPO3_db, $query);
										if ($res2 != '') {
											if (mysql_num_rows($res2) > 0) {
												$units_uid = array();
												while ($row2 = mysql_fetch_assoc($res2))
													$units_uid[] = intval($row2['uid']);
												$query = "UPDATE tx_cs2unitconverter_formulas SET deleted = 1 WHERE source_unit in (".implode(',',$units_uid).")";
								 				$res = mysql(TYPO3_db, $query);
												if ($res == '')
													$errorText = mysql_error();
											}
											if ($errorText == '') {
												$query = "UPDATE tx_cs2unitconverter_units SET deleted = 1 WHERE group_uid in (".implode(',',$groups_uid).")";
								 				$res = mysql(TYPO3_db, $query);
												if ($res == '')
													$errorText = mysql_error();
											}
										} else {
											$errorText = mysql_error();
										}
										if ($errorText == '') {
											$query = "UPDATE tx_cs2unitconverter_groups SET deleted = 1 WHERE uid in (".implode(',',$groups_uid).")";
							 				$res = mysql(TYPO3_db, $query);
											if ($res == '')
												$errorText = mysql_error();
										}
									}
								} else {
									$errorText = mysql_error();
								}
	
								if ($errorText == '') {
									for ($j = 0; $j < count($insertGroup); $j++) {
										$res = $GLOBALS['TYPO3_DB']->exec_INSERTquery(
											'tx_cs2unitconverter_groups',
											array(
												'pid' => $this->id,
												'tstamp' => time(),
												'crdate' => time(),
												'cruser_id' => $BE_USER->user['uid'],
												'deleted' => 0,
												'hidden' => 0,
												'group_name' => $insertGroup[$j][0],
												'group_name_de' => $insertGroup[$j][1]
											)
										);
										if ($res != '') {
											$newID = mysql_insert_id();
											if ($newID > 0) {
												for ($k = 0; $k < count($insertUnit); $k++) {
													$query = "INSERT INTO tx_cs2unitconverter_units (pid, tstamp, crdate, cruser_id, deleted, hidden, unit_name, unit_name_de, shortcut, group_uid) SELECT ".$this->id.",".time().",".time().",".intval($BE_USER->user["uid"]).", 0, 0, '".$insertUnit[$k][0]."', '".$insertUnit[$k][1]."', '".$insertUnit[$k][2]."', uid FROM tx_cs2unitconverter_groups WHERE uid = ".intval($newID);
									 				$res2 = mysql(TYPO3_db, $query);
													if ($res2 == '') {
														$errorText = mysql_error();
														break;
													}
												}
												if ($errorText == '') {
													for ($k = 0; $k < count($insertFormula); $k++) {
														$query = "INSERT INTO tx_cs2unitconverter_formulas (pid, tstamp, crdate, cruser_id, deleted, hidden, source_unit, target_unit, formula) SELECT ".$this->id.",".time().",".time().",".intval($BE_USER->user["uid"]).", 0, 0, t1.uid, t2.uid, '".$insertFormula[$k][2]."' FROM tx_cs2unitconverter_units t1, tx_cs2unitconverter_units t2 WHERE t1.unit_name = '".$insertFormula[$k][0]."' AND t2.unit_name = '".$insertFormula[$k][1]."' AND t1.group_uid = ".intval($newID)." AND t2.group_uid = ".intval($newID);
										 				$res2 = mysql(TYPO3_db, $query);
														if ($res2 == '') {
															$errorText = mysql_error();
															break;
														}
													}
												}
											}
										} else {
											$errorText = mysql_error();
										}
										if ($errorText != '')
											break;
									}
								}
							}
	
							if ($errorText != '')
								break;
						}
					} else {
						$errorText = mysql_error();
					}

					if ($errorText != '') {
						mysql(TYPO3_db, "ROLLBACK");
					} else {
						$errorText = $LANG->getLL('loadOK');
						mysql(TYPO3_db, "COMMIT");
					}
				} else if ($submitLoad && ($checkArea || $checkEnergy || $checkLength || $checkMass || $checkPower || $checkPressure || $checkSpeed || $checkTemperature || $checkVolume)) {
					$userScript='<script language="javascript">';
					$userScript.="if(confirm(\"".$LANG->getLL('loadWarning')."\")) {".
					             " document.unitForm.submit_confirm.value=1;".
					             " document.unitForm.submit()}";
					$userScript.='</script>';
				}
				
				if ($errorText != '') {
					$userScript.='<script language="javascript">';
					$userScript.="alert(\"".$errorText."\");";
					$userScript.='</script>';
				}
				$content.=$listFormulas.$userScript;
				$this->content.=$this->doc->section($LANG->getLL("function4"),$content,0,1);
				break;
		} 
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/cs2_unitconv/mod1/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/cs2_unitconv/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_cs2unitconv_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>