<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Rastislav Birka (rasto@cs2.ch)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Unit Converter' for the 'cs2_unitconv' extension.
 *
 * @author	Rastislav Birka <rasto@cs2.ch>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_cs2unitconv_pi1 extends tslib_pibase {
	var $cObj;	// The backReference to the mother cObj object set at call time
	var $prefixId = "tx_cs2unitconv_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_cs2unitconverter_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "cs2_unitconv";	// The extension key.
	
	var $conf = "";
  var $templateCode = "";
	


	/**
	 * Init Function: here all the needed configuration Values are stored in class variables..
	 *
	 * @param	array		$conf: configuration array from TS
	 * @return	void
	 */
	function init($conf) {
		$this->conf = $conf; //store configuration
		$this->pi_setPiVarDefaults(); // Set default piVars from TS
		$this->pi_loadLL(); // Loading language-labels

		$GLOBALS['TSFE']->set_no_cache();

		// get the template
		$this->templateCode = $this->cObj->fileResource($this->conf["templateFile"]);
		$this->templateCode = $this->templateCode ? $this->templateCode : $this->cObj->fileResource('EXT:cs2_unitconv/pi1/cs2_unitconverter_template.tmpl');
	}



	/**
	 * [Put your description here]
	 */
	function main($content,$conf)	{
		$this->init($conf);
		$content='';
		$userScript = '';
		$errorText = '';
		$formulaScript = '';
		$formulaOptions = array();

		$group = t3lib_div::GPvar("group_name");
		$source = t3lib_div::GPvar("source_name");
		$target = t3lib_div::GPvar("target_name");
		$value = t3lib_div::GPvar("value_name") ? t3lib_div::GPvar("value_name") : 0;
		$language = $GLOBALS['TSFE']->config['config']['language'];

		$template = array();
		$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CONVERTER###");
		$markerArray = array();
		$wrappedSubpartArray = array();
		$markerArray["###CONVERTER_FORM_NAME###"] = 'converter_form';
		$markerArray["###GROUP_TITLE###"] = $this->pi_getLL("groupTitle");
		$markerArray["###SOURCE_TITLE###"] = $this->pi_getLL("sourceTitle");
		$markerArray["###TARGET_TITLE###"] = $this->pi_getLL("targetTitle");
		$markerArray["###VALUE_TITLE###"] = $this->pi_getLL("valueTitle");
		$markerArray["###GROUP_NAME###"] = 'group_name';
		$markerArray["###SOURCE_NAME###"] = 'source_name';
		$markerArray["###TARGET_NAME###"] = 'target_name';
		$markerArray["###VALUE_NAME###"] = 'value_name';
		$markerArray["###GROUP_VALUE###"] = '';
		$markerArray["###SOURCE_VALUE###"] = '';
		$markerArray["###TARGET_VALUE###"] = '';
		$markerArray["###VALUE_VALUE###"] = htmlspecialchars($value);
		$markerArray["###SUBMIT_NAME###"] = 'make_result';
		$markerArray["###SUBMIT_VALUE###"] = $this->pi_getLL('submitButton');
		$markerArray["###RESULT_TITLE###"] = $this->pi_getLL('resultTitle');
		$markerArray["###RESULT_VALUE###"] = '';

		$query = "SELECT t1.* FROM tx_cs2unitconverter_groups t1, tx_cs2unitconverter_units t2, tx_cs2unitconverter_formulas t3";
		$query.= " WHERE t1.deleted = 0 AND t1.hidden = 0";
		$query.= " AND t2.deleted = 0 AND t2.hidden = 0";
		$query.= " AND t3.deleted = 0 AND t3.hidden = 0 AND t3.formula <> ''";
		$query.= " AND t2.uid = t3.source_unit AND t1.uid = t2.group_uid";
		$query.= " GROUP BY t1.uid";
		if ($language == 'de') 
			$query.= " ORDER BY t1.group_name_de";
		else
			$query.= " ORDER BY t1.group_name";
		$res = mysql(TYPO3_db, $query);
		if ($res != '') {
			$i = 0;
			while ($row = mysql_fetch_assoc($res)) {
				if ($language == 'de' && $row['group_name_de']) 
					$textName = $row['group_name_de'];
				else
					$textName = $row['group_name'];
				$formulaOptions[$i] = array('uid'=>$row['uid'], 'name'=>$textName);
				$query = "SELECT t1.* FROM tx_cs2unitconverter_units t1, tx_cs2unitconverter_formulas t2";
				$query.= " WHERE t1.deleted = 0 AND t1.hidden = 0";
				$query.= " AND t2.deleted = 0 AND t2.hidden = 0 AND t2.formula <> ''";
				$query.= " AND t1.uid = t2.source_unit AND t1.group_uid = " . intval($formulaOptions[$i]['uid']);
				$query.= " GROUP BY t1.uid";
				if ($language == 'de') 
					$query.= " ORDER BY t1.unit_name_de";
				else
					$query.= " ORDER BY t1.unit_name";
				$res2 = mysql(TYPO3_db, $query);
				if ($res2 != '') {
					$j = 0;
					$sourceArray = array();
					while ($row2 = mysql_fetch_assoc($res2)) {
						if ($language == 'de' && $row2['unit_name_de']) 
							$textName = $row2['unit_name_de'];
						else
							$textName = $row2['unit_name'];
						if ($row2['shortcut']) 
							$textName.= ' ('.$row2['shortcut'].')';
						$sourceArray[$j] = array('uid'=>$row2['uid'], 'name'=>$textName);
						$query = "SELECT t1.*, t2.formula FROM tx_cs2unitconverter_units t1, tx_cs2unitconverter_formulas t2";
						$query.= " WHERE t1.deleted = 0 AND t1.hidden = 0";
						$query.= " AND t2.deleted = 0 AND t2.hidden = 0 AND t2.formula <> ''";
						$query.= " AND t1.uid = t2.target_unit AND t2.source_unit = " . intval($sourceArray[$j]['uid']);
						$query.= " AND t1.uid <> " . intval($sourceArray[$j]['uid']);
						$query.= " GROUP BY t1.uid";
						if ($language == 'de') 
							$query.= " ORDER BY t1.unit_name_de";
						else
							$query.= " ORDER BY t1.unit_name";
						$res3 = mysql(TYPO3_db, $query);
						if ($res3 != '') {
							$k = 0;
							$targetArray = array();
							while ($row3 = mysql_fetch_assoc($res3)) {
								if ($language == 'de' && $row3['unit_name_de']) 
									$textName = $row3['unit_name_de'];
								else
									$textName = $row3['unit_name'];
								if ($row3['shortcut']) 
									$textName.= ' ('.$row3['shortcut'].')';
								$targetArray[$k] = array('uid'=>$row3['uid'], 'name'=>$textName, 'formula'=>$row3['formula']);
								$k++;
							}
							$sourceArray[$j]['target'] = $targetArray;
						}
						$j++;
					}
					$formulaOptions[$i]['source'] = $sourceArray;
				}
				$i++;
			}
			
			$groupOption = '';
			$sourceOption = '';
			$targetOption = '';
			for ($i = 0; $i < count($formulaOptions); $i++) {
				$op_selected = '';
				if (empty($group))
					$group = $formulaOptions[$i]['uid'];
				if ($formulaOptions[$i]['uid'] == $group) {
					$group = $formulaOptions[$i]['uid'];
					$op_selected = 'SELECTED';
				}
				$groupOption.='<OPTION value="'.$formulaOptions[$i]['uid'].'" '.$op_selected.'>'.$formulaOptions[$i]['name'].'</OPTION>';
			}
			for ($i = 0; $i < count($formulaOptions); $i++) {
				if ($formulaOptions[$i]['uid'] == $group) {
					for ($j = 0; $j < count($formulaOptions[$i]['source']); $j++) {
						$op_selected = '';
						if (empty($source))
							$source = $formulaOptions[$i]['source'][$j]['uid'];
						if ($formulaOptions[$i]['source'][$j]['uid'] == $source) {
							$source = $formulaOptions[$i]['source'][$j]['uid'];
							$op_selected = 'SELECTED';
						}
						$sourceOption.='<OPTION value="'.$formulaOptions[$i]['source'][$j]['uid'].'" '.$op_selected.'>'.$formulaOptions[$i]['source'][$j]['name'].'</OPTION>';
					}
					break;
				}
			}
			for ($i = 0; $i < count($formulaOptions); $i++) {
				if ($formulaOptions[$i]['uid'] == $group) {
					for ($j = 0; $j < count($formulaOptions[$i]['source']); $j++) {
						if ($formulaOptions[$i]['source'][$j]['uid'] == $source) {
							for ($k = 0; $k < count($formulaOptions[$i]['source'][$j]['target']); $k++) {
								$op_selected = '';
								if (empty($target))
									$target = $formulaOptions[$i]['source'][$j]['target'][$k]['uid'];
								if ($formulaOptions[$i]['source'][$j]['target'][$k]['uid'] == $target) {
									$target = $formulaOptions[$i]['source'][$j]['target'][$k]['uid'];
									$op_selected = 'SELECTED';
								}
								$targetOption.='<OPTION value="'.$formulaOptions[$i]['source'][$j]['target'][$k]['uid'].'" '.$op_selected.'>'.$formulaOptions[$i]['source'][$j]['target'][$k]['name'].'</OPTION>';
							}
							break;
						}
					}
					break;
				}
			}

//t3lib_div::print_array($formulaOptions);
			$markerArray["###GROUP_VALUE###"] = $groupOption;
			$markerArray["###SOURCE_VALUE###"] = $sourceOption;
			$markerArray["###TARGET_VALUE###"] = $targetOption;
			$formulaScript = $this->CreateFormulaScript($formulaOptions);
			if ($target > 0) {
 				$query = "SELECT t1.*, t2.unit_name as so_name, t2.unit_name_de as so_name_de, t2.shortcut as so_short, t3.unit_name as ta_name, t3.unit_name_de as ta_name_de, t3.shortcut as ta_short";
				$query.= " FROM tx_cs2unitconverter_formulas t1, tx_cs2unitconverter_units t2, tx_cs2unitconverter_units t3";
				$query.= " WHERE t1.formula <> '' AND t1.source_unit = ".$GLOBALS['TYPO3_DB']->quoteStr($source,'')." AND t1.target_unit = ".$GLOBALS['TYPO3_DB']->quoteStr($target,'');
				$query.= " AND t2.uid = source_unit AND t3.uid = target_unit";
				$query.= " AND t1.deleted = 0 AND t1.hidden = 0";
				$query.= " AND t2.deleted = 0 AND t2.hidden = 0";
				$query.= " AND t3.deleted = 0 AND t3.hidden = 0";
				$res = mysql(TYPO3_db, $query);
				if ($res != '') {
					if ($row = mysql_fetch_assoc($res)) {
						$value = str_replace(',', '.', $value);
						$formula = str_replace(',', '.', $row['formula']);
						$temp = str_replace('X', $value, $formula);
						eval("\$result = $temp;");
						if ($row['so_short'])
							$textNameSo = $row['so_short'];
						else if ($language == 'de' && $row['so_name_de'])
							$textNameSo = $row['so_name_de'];
						else
							$textNameSo = $row['so_name'];
						if ($row['ta_short'])
							$textNameTa = $row['ta_short'];
						else if ($language == 'de' && $row['ta_name_de'])
							$textNameTa = $row['ta_name_de'];
						else
							$textNameTa = $row['ta_name'];
						$markerArray["###RESULT_VALUE###"] = htmlspecialchars($value)." ".htmlspecialchars($textNameSo)." = ".$result." ".$textNameTa;
					} else {
						$errorText = $this->pi_getLL('errorFormula');
					}
				} else {
					t3lib_div::debug(mysql_error());
				}
			}
		} else {
			t3lib_div::debug(mysql_error());
		}
		if (!empty($errorText)) {
			$userScript ='<script language="javascript">';
			$userScript.="alert(\"".$errorText."\");";
			$userScript.='</script>';
		}  

		$content = $this->cObj->substituteMarkerArrayCached($template, array(), $markerArray , $wrappedSubpartArray);
		$content.= $userScript.$formulaScript;

		return $this->pi_wrapInBaseClass($content);
	}



	function CreateFormulaScript($formulaOptions) {
		$content = '<script language="javascript">';
		$content.= 'var arrValues = new Array();';
		foreach($formulaOptions as $key => $val) {
			$content.= 'arrValues['.$key.'] = new Array();';
			foreach($val["source"] as $key2 => $val2) {
				$content.= 'arrValues['.$key.'][arrValues['.$key.'].length] = new Array('.$val2["uid"].',"'.$val2["name"].'");';
				$content.= 'arrValues['.$key.'][arrValues['.$key.'].length-1][2] = new Array();';
				foreach($val2["target"] as $key3 => $val3) {
					$content.='arrValues['.$key.'][arrValues['.$key.'].length-1][2][arrValues['.$key.'][arrValues['.$key.'].length-1][2].length] = new Array('.$val3["uid"].',"'.$val3["name"].'");';
				}
			}
		}

		$content.= '
								var gObj = document.converter_form.group_name;
								var sObj = document.converter_form.source_name;
								var tObj = document.converter_form.target_name;
								function ChangeGroup() {
									sObj.selectedIndex = 0;
									for(var i = sObj.length - 1; i >= 0; i--)
										sObj.options[i] = null;
									var j = 0;
									for(var i = 0; i < arrValues[gObj.selectedIndex].length; i++) {
										sObj.options[j] = new Option(arrValues[gObj.selectedIndex][i][1], arrValues[gObj.selectedIndex][i][0]);
										j++;
									}
									ChangeUnit();
								}
								function ChangeUnit() {
									tObj.selectedIndex = 0;
									for(var i = tObj.length - 1; i >= 0; i--)
										tObj.options[i] = null;
									var j = 0;
									for(var i = 0; i < arrValues[gObj.selectedIndex][sObj.selectedIndex][2].length; i++) {
										tObj.options[j] = new Option(arrValues[gObj.selectedIndex][sObj.selectedIndex][2][i][1], arrValues[gObj.selectedIndex][sObj.selectedIndex][2][i][0]);
										j++;
									}
								}
							';
		$content.= '</script>';
		return $content;
	}
	
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/cs2_unitconv/pi1/class.tx_cs2unitconverter_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/cs2_unitconv/pi1/class.tx_cs2unitconverter_pi1.php"]);
}

?>